﻿using System;
using System.ComponentModel;
using System.Drawing;
using System.Collections.Generic; // Added
using System.Windows.Forms;
using Fidelity.Components;
using CtrlLib;
using WealthLab;
using WealthLab.PosSizers;
using WealthLab.Indicators;

namespace Abacus.PosSizers
{
    public class Abacus : PosSizerSettingsBase
    {
        private IContainer components = null;
        private GroupBox gb1;
        private GroupBox gb2;
        private Label volumePercentLabel;
        private Label daysToAverageLabel;
        private NumericUpDown percentOfAverageVolume;
        private Label label2;
        private ComboBox percentOfEquity;
        private CheckBox skippedTradeSolution;
        private Label label6;
        private Label label5;
        private Label label4;
        private Label label3;
        private RadioButton spreadEquityEqually;
        private Label label1;
        private NumericUpDown daysToAverage;

        public Abacus()
        {
            try
            {
                this.InitializeComponent();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Message: " + ex.Message + "\n" +
                "InnerException: " + ex.InnerException);
            }
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.gb1 = new System.Windows.Forms.GroupBox();
            this.label6 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.spreadEquityEqually = new System.Windows.Forms.RadioButton();
            this.skippedTradeSolution = new System.Windows.Forms.CheckBox();
            this.label2 = new System.Windows.Forms.Label();
            this.percentOfEquity = new System.Windows.Forms.ComboBox();
            this.gb2 = new System.Windows.Forms.GroupBox();
            this.label1 = new System.Windows.Forms.Label();
            this.percentOfAverageVolume = new System.Windows.Forms.NumericUpDown();
            this.daysToAverage = new System.Windows.Forms.NumericUpDown();
            this.volumePercentLabel = new System.Windows.Forms.Label();
            this.daysToAverageLabel = new System.Windows.Forms.Label();
            this.gb1.SuspendLayout();
            this.gb2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.percentOfAverageVolume)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.daysToAverage)).BeginInit();
            this.SuspendLayout();
            // 
            // lblDesc
            // 
            this.lblDesc.Location = new System.Drawing.Point(6, 16);
            this.lblDesc.Size = new System.Drawing.Size(224, 40);
            this.lblDesc.Text = "This PosSizer limits positions to selected percent of average volume over selecte" +
    "d number of days";
            // 
            // rbFixedDollar
            // 
            this.rbFixedDollar.Location = new System.Drawing.Point(6, 60);
            // 
            // rbPctEquity
            // 
            this.rbPctEquity.Location = new System.Drawing.Point(6, 85);
            // 
            // rbMaxRisk
            // 
            this.rbMaxRisk.Location = new System.Drawing.Point(6, 110);
            // 
            // numFixedDollar
            // 
            this.numFixedDollar.Location = new System.Drawing.Point(109, 60);
            this.numFixedDollar.Text = "1000000";
            this.numFixedDollar.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            // 
            // numPctEquity
            // 
            this.numPctEquity.Location = new System.Drawing.Point(109, 85);
            this.numPctEquity.Text = "10";
            this.numPctEquity.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            // 
            // numMaxRisk
            // 
            this.numMaxRisk.Location = new System.Drawing.Point(109, 110);
            this.numMaxRisk.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.numMaxRisk.Text = "10";
            this.numMaxRisk.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            // 
            // gb1
            // 
            this.gb1.Controls.Add(this.label6);
            this.gb1.Controls.Add(this.label5);
            this.gb1.Controls.Add(this.label4);
            this.gb1.Controls.Add(this.label3);
            this.gb1.Controls.Add(this.spreadEquityEqually);
            this.gb1.Controls.Add(this.skippedTradeSolution);
            this.gb1.Controls.Add(this.label2);
            this.gb1.Controls.Add(this.percentOfEquity);
            this.gb1.Controls.Add(this.lblDesc);
            this.gb1.Controls.Add(this.rbFixedDollar);
            this.gb1.Controls.Add(this.rbPctEquity);
            this.gb1.Controls.Add(this.rbMaxRisk);
            this.gb1.Controls.Add(this.numFixedDollar);
            this.gb1.Controls.Add(this.numPctEquity);
            this.gb1.Controls.Add(this.numMaxRisk);
            this.gb1.Location = new System.Drawing.Point(0, 3);
            this.gb1.Name = "gb1";
            this.gb1.Size = new System.Drawing.Size(233, 208);
            this.gb1.TabIndex = 0;
            this.gb1.TabStop = false;
            this.gb1.Controls.SetChildIndex(this.numMaxRisk, 0);
            this.gb1.Controls.SetChildIndex(this.numPctEquity, 0);
            this.gb1.Controls.SetChildIndex(this.numFixedDollar, 0);
            this.gb1.Controls.SetChildIndex(this.rbMaxRisk, 0);
            this.gb1.Controls.SetChildIndex(this.rbPctEquity, 0);
            this.gb1.Controls.SetChildIndex(this.rbFixedDollar, 0);
            this.gb1.Controls.SetChildIndex(this.lblDesc, 0);
            this.gb1.Controls.SetChildIndex(this.percentOfEquity, 0);
            this.gb1.Controls.SetChildIndex(this.label2, 0);
            this.gb1.Controls.SetChildIndex(this.skippedTradeSolution, 0);
            this.gb1.Controls.SetChildIndex(this.spreadEquityEqually, 0);
            this.gb1.Controls.SetChildIndex(this.label3, 0);
            this.gb1.Controls.SetChildIndex(this.label4, 0);
            this.gb1.Controls.SetChildIndex(this.label5, 0);
            this.gb1.Controls.SetChildIndex(this.label6, 0);
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(92, 63);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(13, 13);
            this.label6.TabIndex = 19;
            this.label6.Text = "$";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(213, 89);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(15, 13);
            this.label5.TabIndex = 18;
            this.label5.Text = "%";
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(215, 114);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(15, 13);
            this.label4.TabIndex = 5;
            this.label4.Text = "%";
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(213, 161);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(15, 13);
            this.label3.TabIndex = 17;
            this.label3.Text = "%";
            // 
            // spreadEquityEqually
            // 
            this.spreadEquityEqually.AutoSize = true;
            this.spreadEquityEqually.Location = new System.Drawing.Point(6, 133);
            this.spreadEquityEqually.Name = "spreadEquityEqually";
            this.spreadEquityEqually.Size = new System.Drawing.Size(128, 17);
            this.spreadEquityEqually.TabIndex = 16;
            this.spreadEquityEqually.TabStop = true;
            this.spreadEquityEqually.Text = "Spread Equity Equally";
            this.spreadEquityEqually.UseVisualStyleBackColor = true;
            // 
            // skippedTradeSolution
            // 
            this.skippedTradeSolution.AutoSize = true;
            this.skippedTradeSolution.Location = new System.Drawing.Point(6, 185);
            this.skippedTradeSolution.Name = "skippedTradeSolution";
            this.skippedTradeSolution.Size = new System.Drawing.Size(137, 17);
            this.skippedTradeSolution.TabIndex = 15;
            this.skippedTradeSolution.Text = "Skipped Trade Solution";
            this.skippedTradeSolution.UseVisualStyleBackColor = true;
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.label2.Location = new System.Drawing.Point(6, 161);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(109, 13);
            this.label2.TabIndex = 11;
            this.label2.Text = "Equity for First Trades";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // percentOfEquity
            // 
            this.percentOfEquity.FormattingEnabled = true;
            this.percentOfEquity.Items.AddRange(new object[] {
            "100%",
            "50%"});
            this.percentOfEquity.Location = new System.Drawing.Point(148, 158);
            this.percentOfEquity.Name = "percentOfEquity";
            this.percentOfEquity.Size = new System.Drawing.Size(59, 21);
            this.percentOfEquity.TabIndex = 9;
            // 
            // gb2
            // 
            this.gb2.Controls.Add(this.label1);
            this.gb2.Controls.Add(this.percentOfAverageVolume);
            this.gb2.Controls.Add(this.daysToAverage);
            this.gb2.Controls.Add(this.volumePercentLabel);
            this.gb2.Controls.Add(this.daysToAverageLabel);
            this.gb2.Location = new System.Drawing.Point(0, 217);
            this.gb2.Name = "gb2";
            this.gb2.Size = new System.Drawing.Size(236, 75);
            this.gb2.TabIndex = 1;
            this.gb2.TabStop = false;
            this.gb2.Text = "Average Volume";
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(213, 22);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(15, 13);
            this.label1.TabIndex = 4;
            this.label1.Text = "%";
            // 
            // percentOfAverageVolume
            // 
            this.percentOfAverageVolume.DecimalPlaces = 2;
            this.percentOfAverageVolume.Increment = new decimal(new int[] {
            25,
            0,
            0,
            131072});
            this.percentOfAverageVolume.Location = new System.Drawing.Point(157, 20);
            this.percentOfAverageVolume.Maximum = new decimal(new int[] {
            5,
            0,
            0,
            0});
            this.percentOfAverageVolume.Minimum = new decimal(new int[] {
            5,
            0,
            0,
            65536});
            this.percentOfAverageVolume.Name = "percentOfAverageVolume";
            this.percentOfAverageVolume.Size = new System.Drawing.Size(50, 20);
            this.percentOfAverageVolume.TabIndex = 0;
            this.percentOfAverageVolume.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.percentOfAverageVolume.Value = new decimal(new int[] {
            15,
            0,
            0,
            65536});
            // 
            // daysToAverage
            // 
            this.daysToAverage.Location = new System.Drawing.Point(157, 48);
            this.daysToAverage.Maximum = new decimal(new int[] {
            20,
            0,
            0,
            0});
            this.daysToAverage.Minimum = new decimal(new int[] {
            2,
            0,
            0,
            0});
            this.daysToAverage.Name = "daysToAverage";
            this.daysToAverage.Size = new System.Drawing.Size(50, 20);
            this.daysToAverage.TabIndex = 1;
            this.daysToAverage.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.daysToAverage.Value = new decimal(new int[] {
            10,
            0,
            0,
            0});
            // 
            // volumePercentLabel
            // 
            this.volumePercentLabel.Location = new System.Drawing.Point(3, 22);
            this.volumePercentLabel.Name = "volumePercentLabel";
            this.volumePercentLabel.Size = new System.Drawing.Size(150, 18);
            this.volumePercentLabel.TabIndex = 2;
            this.volumePercentLabel.Text = "Percent of Average Volume";
            // 
            // daysToAverageLabel
            // 
            this.daysToAverageLabel.Location = new System.Drawing.Point(3, 50);
            this.daysToAverageLabel.Name = "daysToAverageLabel";
            this.daysToAverageLabel.Size = new System.Drawing.Size(110, 18);
            this.daysToAverageLabel.TabIndex = 3;
            this.daysToAverageLabel.Text = "Days to Average";
            // 
            // Abacus
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.BackColor = System.Drawing.SystemColors.Control;
            this.Controls.Add(this.gb1);
            this.Controls.Add(this.gb2);
            this.FixedDollarSize = 1000000D;
            this.MaxRiskSize = 10D;
            this.Name = "Abacus";
            this.PctEquitySize = 10D;
            this.Size = new System.Drawing.Size(236, 295);
            this.gb1.ResumeLayout(false);
            this.gb1.PerformLayout();
            this.gb2.ResumeLayout(false);
            this.gb2.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.percentOfAverageVolume)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.daysToAverage)).EndInit();
            this.ResumeLayout(false);

        }
        public bool SpreadEquityEqually
        {
            get
            {
                return (bool)this.spreadEquityEqually.Checked;
            }
            set
            {
                this.spreadEquityEqually.Checked = value;
            }
        }
        public int PercentOfEquityValue
        {
            get
            {
                return (int)this.percentOfEquity.SelectedIndex;
            }
            set
            {
                this.percentOfEquity.SelectedIndex = value;
            }
        }
        public bool SkippedTradeSolution
        {
            get
            {
                return (bool)this.skippedTradeSolution.Checked;
            }
            set
            {
                this.skippedTradeSolution.Checked = value;
            }
        }
        public double PercentOfAverageVolume
        {
            get
            {
                return (double)this.percentOfAverageVolume.Value;
            }
            set
            {
                this.percentOfAverageVolume.Text = value.ToString();
            }
        }
        public int DaysToAverage
        {
            get
            {
                return (int)this.daysToAverage.Value;
            }
            set
            {
                this.daysToAverage.Text = value.ToString();
            }
        }
    }

    public class AbacusPosSizer : BasicPosSizer, ICustomSettings
    {
        private bool _spreadEquityEqually = false;
        private int _percentOfEquityValue = 0;
        private bool _skippedTradeSolution = false;
        private double _percentOfAverageVolume = 1.5;
        private int _daysToAverage = 10;

        private Abacus _settings = new Abacus();

        /*
        int currentPosNumber;
        DateTime currentPosDate;
        DateTime firstTrade = DateTime.Now;
        int[] unsizedPositions = new int[1000];
        double[] calculatedBasisPrice = new double[1000];
        double[] averageVolumeLimitation = new double[1000];
        double[] calculatedSize = new double [1000];
        */
        double size;
         
       
        public override double SizePosition(Position currentPos, Bars bars, int bar, double basisPrice, PositionType pt, double riskStopLevel, double equity, double cash)
        {
            // Check all Positions
            /*
            for (int n = 0; n < Positions.Count; n++)
            {
                // Find currentPos
                if (Positions[n].Bars == bars
                    && Positions[n].EntryBar == bar
                    && Positions[n].BasisPrice == basisPrice
                    && Positions[n].PositionType == pt)
                {
                    currentPosNumber = n;
                    currentPosDate = Positions[n].EntryDate;
                    unsizedPositions.Add(n);
                }
                /*
                // Find all other entries on that date
                else if (Positions[n].EntryDate == currentPosDate
                    && Positions[n].Shares == 1)
                {
                    // Add then number of the position to unsizedPositions
                    unsizedPositions.Add(n);

                    // Reduce equity by the equity used for that position
                    //equity -= Positions[n].Size;
                    // Abacus commission
                    //equity -= 5;
                }
                
                // Determine the first trade date
                if (Positions[n].EntryDate < firstTrade)
                    firstTrade = Positions[n].EntryDate;
            }
            */
            /*
            // Only use 50% of Equity if Equity for First Trades = 50%
            // ADDING 33% AS AN OPTION GETS COMPLICATED, BECAUSE YOU HAVE TO REDUCE THE EQUITY ON THE SECOND TRADE ALSO
            if (currentPosDate == firstTrade
                && _settings.PercentOfEquityValue == 1)
                equity /= 2;
            */
            // Size all Unsized Positions
            //for (int n = unsizedPositions.Count - 1; n >= 0 ; n--)
            //{
                /*
                // Skipped Trade Solution
                if (_settings.SkippedTradeSolution
                    && bar < bars.Count - 1)
                {
                    if (Positions[n].EntryOrderType == OrderType.Market)
                        calculatedBasisPrice[n] = Positions[n].Bars.Open[Positions[n].EntryBar];
                    if (Positions[n].EntryOrderType == OrderType.AtClose)
                        calculatedBasisPrice[n] = Positions[n].Bars.Close[Positions[n].EntryBar];
                }
                else
                */
                //  calculatedBasisPrice[n] = Positions[n].Bars.Close[Positions[n].EntryBar - 1];
                
                // Basic Position Sizing
                //calculatedSize[n] = base.CalcPositionSize(base.PosSizeMode, base.GetPosSizeValue(base.PosSizeMode, base.FixedDollarSize, base.PctEquitySize, base.MaxRiskSize), Positions[n].Bars, Positions[n].EntryBar, Positions[n].PositionType, calculatedBasisPrice[n], Positions[n].RiskStopLevel, equity);
            //calculatedBasisPrice[n] = basisPrice;
            
            size = base.CalcPositionSize(base.PosSizeMode, base.GetPosSizeValue(base.PosSizeMode, base.FixedDollarSize, base.PctEquitySize, base.MaxRiskSize), bars, bar, pt, basisPrice, riskStopLevel, equity);
            
            /*
            double[] calculatedBasisPrice = new double[1000];
            double[] calculatedSize = new double[1000];
            int n = 0;
            calculatedBasisPrice[n] = Positions[n].BasisPrice;
            calculatedSize[n] = base.CalcPositionSize(base.PosSizeMode, base.GetPosSizeValue(base.PosSizeMode, base.FixedDollarSize, base.PctEquitySize, base.MaxRiskSize), bars, bar, pt, calculatedBasisPrice[n], riskStopLevel, equity);
            size = calculatedSize[n];
            */           
            
            //calculatedSize[n] = base.CalcPositionSize(base.PosSizeMode, base.GetPosSizeValue(base.PosSizeMode, base.FixedDollarSize, base.PctEquitySize, base.MaxRiskSize), Positions[n].Bars, Positions[n].EntryBar, Positions[n].PositionType, calculatedBasisPrice[n], Positions[n].RiskStopLevel, equity);

                /*
                // Average Volume Calculation
                averageVolumeLimitation[n] = _settings.PercentOfAverageVolume / 100 * SMA.Value(Positions[n].EntryBar - 1, Positions[n].Bars.Volume, _settings.DaysToAverage);
                // Round down to the nearest 100 shares
                averageVolumeLimitation[n] = Math.Round(averageVolumeLimitation[n] / 100, 0) * 100;
                        
                // Reduce size if necessary
                if (averageVolumeLimitation[n] < calculatedSize[n])
                {
                    calculatedSize[n] = averageVolumeLimitation[n];
                    if(n == currentPosNumber)
                    {
                        // Nothing more to do for currentPos
                        goto ReturnSize; 
                    }
                    else
                    {
                        // Round down to the nearest 100 shares
                        calculatedSize[n] = Math.Round(calculatedSize[n] / 100, 0) * 100;
                        // Reduce equity by this position
                        equity -= calculatedSize[n] * calculatedBasisPrice[n] + 5;
                        // Remove position from the lists
                        unsizedPositions.RemoveAt(n);
                        calculatedBasisPrice.RemoveAt(n);
                        averageVolumeLimitation.RemoveAt(n);
                        calculatedSize.RemoveAt(n);
                    }
                }
                
                // Reduce the size of the last position if it exceeds equity
                if (unsizedPositions.Count == 1
                    && calculatedSize[n] * calculatedBasisPrice[n] + 5 > equity)
                    calculatedSize[n] = (equity - 5) / calculatedBasisPrice[n];
                */
                // Round size down to the nearest 100 shares
                //calculatedSize[0] = Math.Round(calculatedSize[0] / 100, 0) * 100;
                
            //}
            /*
            // Spread Equity Equally, unless currentPos is already limited by Average Volume
            if (calculatedSize[currentPosNumber] != averageVolumeLimitation[currentPosNumber]
                && _settings.SpreadEquityEqually)
            {
                // while (unsizedPositions.Count > 1)
                //{ 
                for (int n = unsizedPositions.Count - 1; n >= 0; n--)
                {
                    calculatedSize[n] = ((equity / unsizedPositions.Count) - 5) / calculatedBasisPrice[n];
                    // Reduce size if necessary
                    if (averageVolumeLimitation[n] < calculatedSize[n])
                    {
                        calculatedSize[n] = averageVolumeLimitation[n];
                        if (n == currentPosNumber)
                        {
                            // Nothing more to do for currentPos
                            goto ReturnSize;
                        }
                        else
                        {
                            // Round down to the nearest 100 shares
                            calculatedSize[n] = Math.Round(calculatedSize[n] / 100, 0) * 100;
                            // Reduce equity by this position
                            equity -= calculatedSize[n] * calculatedBasisPrice[n] + 5;
                            // Remove position from the lists
                            unsizedPositions.RemoveAt(n);
                            calculatedBasisPrice.RemoveAt(n);
                            averageVolumeLimitation.RemoveAt(n);
                            calculatedSize.RemoveAt(n);
                        }
                    }
                }
                //}
                // DELETE THIS ONCE YOU ARE SURE IT IS RUNNING 
                for (int n = unsizedPositions.Count - 1; n >= 0; n--)
                {
                    calculatedSize[n] = ((equity / unsizedPositions.Count) - 5) / calculatedBasisPrice[n];
                    // Reduce size if necessary
                    if (averageVolumeLimitation[n] < calculatedSize[n])
                    {
                        calculatedSize[n] = averageVolumeLimitation[n];
                        if (n == currentPosNumber)
                        {
                            // Nothing more to do for currentPos
                            goto ReturnSize;
                        }
                        else
                        {
                            // Round down to the nearest 100 shares
                            calculatedSize[n] = Math.Round(calculatedSize[n] / 100, 0) * 100;
                            // Reduce equity by this position
                            equity -= calculatedSize[n] * calculatedBasisPrice[n] + 5;
                            // Remove position from the lists
                            unsizedPositions.RemoveAt(n);
                            calculatedBasisPrice.RemoveAt(n);
                            averageVolumeLimitation.RemoveAt(n);
                            calculatedSize.RemoveAt(n);
                        }
                    }
                }
            }
            */
            ReturnSize:
            // Return size of currentPos
            //size = calculatedSize[n];
            return size;
        }

        public override string GetConfigString()
        {
            return base.GetConfigString()
                + this._spreadEquityEqually + "|"
                + this._percentOfEquityValue + "|"
                + this._skippedTradeSolution + "|"
                + this._percentOfAverageVolume + "|"
                + this._daysToAverage + "|";
        }

        public override void ApplyConfigString(string config)
        {
            base.ApplyConfigString(config);
            string[] tokens = config.Split('|');
            this._spreadEquityEqually = Boolean.Parse(tokens[4]);
            this._percentOfEquityValue = Int32.Parse(tokens[5]);
            this._skippedTradeSolution = Boolean.Parse(tokens[6]);
            this._percentOfAverageVolume = Double.Parse(tokens[7]);
            this._daysToAverage = Int32.Parse(tokens[8]);
            //this._percentOfAverageVolume = Double.Parse(tokens[4]);
            //this._daysToAverage = Int32.Parse(tokens[5]);
        }
        
        public void ChangeSettings(UserControl ui)
        {
            base.ChangeBasicSettings(this._settings);
            this._spreadEquityEqually = this._settings.SpreadEquityEqually;
            this._percentOfEquityValue = this._settings.PercentOfEquityValue;
            this._skippedTradeSolution = this._settings.SkippedTradeSolution;
            this._percentOfAverageVolume = this._settings.PercentOfAverageVolume;
            this._daysToAverage = this._settings.DaysToAverage;
        }

        public UserControl GetSettingsUI()
        {
            base.InitializeSettings(this._settings);
            this._settings.SpreadEquityEqually = this._spreadEquityEqually;
            this._settings.PercentOfEquityValue = this._percentOfEquityValue;
            this._settings.SkippedTradeSolution = this._skippedTradeSolution;
            this._settings.PercentOfAverageVolume = this._percentOfAverageVolume;
            this._settings.DaysToAverage = this._daysToAverage;
            return this._settings;
        }

        public void ReadSettings(ISettingsHost host)
        {
            base.ReadBasicSettings(host);
            string s = "PosSizer.Abacus.";//AverageVolumeLimitation
            this._spreadEquityEqually = host.Get(s + "SpreadEquityEqually", (bool)false);
            this._percentOfEquityValue = host.Get(s + "PercentOfEquityValue", (int)0);
            this._skippedTradeSolution = host.Get(s + "SkippedTradeSolution", (bool)false);
            this._percentOfAverageVolume = host.Get(s + "PercentOfAverageVolume", (double)1.5);
            this._daysToAverage = host.Get(s + "DaysToAverage", (int)10);
        }

        public void WriteSettings(ISettingsHost host)
        {
            base.WriteBasicSettings(host);
            string s = "PosSizer.Abacus.";//AverageVolumeLimitation
            host.Set(s + "SpreadEquityEqually", this._settings.SpreadEquityEqually);
            host.Set(s + "PercentOfEquityValue", this._settings.PercentOfEquityValue);
            host.Set(s + "SkippedTradeSolution", this._settings.SkippedTradeSolution);
            host.Set(s + "PercentOfAverageVolume", this._percentOfAverageVolume);
            host.Set(s + "DaysToAverage", this._daysToAverage);
        }

        public override string FriendlyName
        {
            get
            {
                return "Abacus";
            }
        }
    }
}
